Attribute VB_Name = "PCF8574"
Declare Sub OPENCOM Lib "RSAPI.DLL" (ByVal Param$)
Declare Sub CLOSECOM Lib "RSAPI.DLL" ()
Declare Sub DTR Lib "RSAPI.DLL" (ByVal Pegel%)
Declare Sub RTS Lib "RSAPI.DLL" (ByVal Pegel%)
Declare Sub TXD Lib "RSAPI.DLL" (ByVal Pegel%)
Declare Function CTS Lib "RSAPI.DLL" () As Integer
Declare Sub DELAY Lib "RSAPI.DLL" (ByVal ms%)

Sub MAIN()
    i2cInit
Selection.TypeParagraph
    For n = 1 To 15
        Selection.TypeText Text:=Str$(n) + Chr$(9)
        i2cStart
        i2cOut 64: Rem Bus-Adresse PCF8574
        i2cOut n: Rem Ausgabewert zum Port
        i2cStop
        i2cStart
        i2cOut 65: Rem PCF8574 lesen
        Ein = i2cIn
        i2cNoAck
        Selection.TypeText Text:=Str$(Ein)
        Selection.TypeParagraph
        Debug.Print Ein
        DELAY 100
        i2cStop
    Next n
    DELAY 2000
End Sub

Sub i2cInit()
    OPENCOM "COM2:300,n,8,1"
    TXD 1: Rem  Spannungsversorgung ein
    DELAY 30
    DTR 0: Rem SDA=1
    RTS 0: Rem SCL=1
    DELAY 100
End Sub

Sub i2cStart()
    DTR 1
    RTS 1
End Sub

Sub i2cStop()
        DTR 1
    RTS 0
    DTR 0
End Sub

Sub i2cOut(Wert)
    Bit = 128
    For n = 1 To 8
      If (Wert And Bit) = 0 Then DTR 1 Else DTR 0
      RTS 0
      RTS 1
      Bit = Bit / 2
    Next n
    DTR 0
    RTS 0
    If CTS = 0 Then Debug.Print "Fehler!"
    RTS 1
End Sub

Sub i2cAck()
    DTR 1
    RTS 0: Rem Ack
    RTS 1
    DTR 0
End Sub

Sub i2cNoAck()
    DTR 0
    RTS 0: Rem I2cAck
    RTS 1
End Sub

Function i2cIn()
    Bit = 128
    Wert = 0
    For n = 1 To 8
        RTS 0
        If CTS = 0 Then Wert = Wert + Bit
        RTS 1
        Bit = Bit / 2
    Next n
    i2cIn = Wert
End Function

